/**************************************************

  Super Drop Edit and Drop List Demo by Andrew J. McGee
  E-Mail: jaym25@3ptech.com
  Last Revision Date: 12/5/97

  Copyright (c) 1997 by Andrew J. McGee
  This Source Code may not be distributed to any other person
  without the express written permission of the Author

  The Author may also be contacted via snail mail:
     PO Box 80336
     Baton Rouge, LA 70898 USA
****************************************************/

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SDropDemo1.h"
#include "SDropDemo2.h"
//---------------------------------------------------------------------------
#pragma link "SDropLst"
#pragma link "STools"
#pragma resource "*.dfm"
TfrmDropDemo *frmDropDemo;
//---------------------------------------------------------------------------
__fastcall TfrmDropDemo::TfrmDropDemo(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::rgOnSelectClick(TObject *Sender)
{
  switch(rgOnSelect->ItemIndex){
    case 0:{SDropList1->List->DoOnClick= doTakeValue;
       SDropList1->List->DoOnReturnKey= doTakeValue; break;}
    case 1:{SDropList1->List->DoOnClick= doDefault;
       SDropList1->List->DoOnReturnKey= doDefault; break;}
    case 2:{SDropList1->List->DoOnClick= doGoAway;
       SDropList1->List->DoOnReturnKey= doGoAway; break;}}
   SDropList1->DisplayForm(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::cbStyleClick(TObject *Sender)
{
  if(cbStyle->Checked)SDropList1->Style=dlsDropDownList;
  else SDropList1->Style=dlsDropDown;
  SDropList1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::cbDropFocusClick(TObject *Sender)
{
  if(cbDropFocus->Checked)
    SDropList1->DropDownOn=SDropList1->DropDownOn << DropOnGetFocus;
    else SDropList1->DropDownOn=SDropList1->DropDownOn >> DropOnGetFocus;
  SDropList1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::cbDropAltDnClick(TObject *Sender)
{
  if(cbDropAltDn->Checked)
    SDropList1->DropDownOn=SDropList1->DropDownOn << DropOnAltArrow;
    else SDropList1->DropDownOn=SDropList1->DropDownOn >> DropOnAltArrow;
  SDropList1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::cbCaretClick(TObject *Sender)
{
 SDropList1->CaretAtEnd=cbCaret->Checked;
 SDropList1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::rgBorderStyleClick(TObject *Sender)
{
  switch(rgBorderStyle->ItemIndex){
    case 0:{SDropList1->ParentColor=True;
        SDropList1->BorderStyle=bsNone; break;}
    case 1:{SDropList1->Color=clWindow;
        SDropList1->BorderStyle=bsSingle;
        SDropList1->Ctl3D=False; break;}
    case 2:{SDropList1->Color=clWindow;
        SDropList1->BorderStyle=bsSingle;
        SDropList1->Ctl3D=True; break;}}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::rgShowButtonClick(TObject *Sender)
{
  switch(rgShowButton->ItemIndex){
    case 0: SDropList1->ButtonShow=btnShowYes; break;
    case 1: SDropList1->ButtonShow=btnShowNo; break;
    case 2: SDropList1->ButtonShow=btnShowFocus; break;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::rgButtonPosClick(TObject *Sender)
{
  switch(rgButtonPos->ItemIndex){
    case 0: SDropList1->ButtonAlign=btnRight; break;
    case 1: SDropList1->ButtonAlign=btnLeft; break;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::cbStayDownClick(TObject *Sender)
{
  SDropList1->ButtonStayDown=cbStayDown->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::SDropList5DrawListItem(TWinControl *Control,
	int Index, TRect &Rect, TOwnerDrawState State)
{
/*  AnsiString TempStr1, TempStr2;
  tagRECT *Rect1, *Rect2;
  Integer I,J,K;
  TempStr1= static_cast<TSDropList*>(Control->Owner)->Items->Strings[Index];
  TempStr1->SetLength(TempStr1->Pos("::")-1);
  TempStr2= static_cast<TSDropList*>(Control->Owner)->Items->Strings[Index];
  TempStr2->Delete(1, TempStr2->Pos("::")+1);
  I=TempStr2->Pos("&");J=0;K=0;
    while(I > 0){
      J=J+I+K; TempStr2.Insert("&",J); ++K;
      I=TempStr2.Pos("&")+J+K;}
      SetRect(Rect1,static_cast<TDropListLB*>(Control)->Canvas->Rectangle->Left,
        static_cast<TDropListLB*>(Control)->Canvas->Rectangle->Top,
        static_cast<TDropListLB*>(Control)->Canvas->Rectangle->Left
         +static_cast<TDropListLB*>(Control)->Canvas.TextWidth("WWW"),
        static_cast<TDropListLB*>(Control)->Canvas->Rectangle->Bottom);
      SetRect(Rect2,Rect1.Right,
        static_cast<TDropListLB*>(Control)->Canvas->Rectangle.Top,
        static_cast<TDropListLB*>(Control)->Canvas->Rectangle.Right,
        static_cast<TDropListLB*>(Control)->Canvas->Rectangle.Bottom);
    DrawTextEx(static_cast<TDropListLB*>(Control)->Canvas->Handle,
     TempStr1,TempStr1.Length(),Rect1,DT_END_ELLIPSIS, NULL);
    DrawTextEx(static_cast<TDropListLB*>(Control)->Canvas->Handle,
     TempStr2,TempStr2.Length(),Rect2,DT_END_ELLIPSIS, NULL);
*/}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::SDropEdit1WantForm(TObject *Sender,
	TForm *&SubForm, bool &DestroyOnClose)
{
 SubForm=frmDropEdit;
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::SDropEdit1Exit(TObject *Sender)
{
  SDropEdit1->CloseForm();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::SDropList4AutoExpand(TObject *Sender, bool Hit,
	bool &Revert, AnsiString &NewText)
{
  if(!Hit){Revert=True; Beep(0,0);}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::SDropList2Click(TObject *Sender)
{
  if(SDropList2->Showing())SDropList2->CloseForm();
  else SDropList2->DisplayForm(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::TabControl1Change(TObject *Sender)
{
switch(static_cast<TTabControl*>(Sender)->TabIndex){
   case 0: Memo1->BringToFront(); break;
   case 1: Memo2->BringToFront(); break;}
}
//---------------------------------------------------------------------------
void __fastcall TfrmDropDemo::FormShow(TObject *Sender)
{
TabControl1->SetFocus();    
}
//---------------------------------------------------------------------------
